require("luaprof")

local hook = hook

local StartProfiler = StartProfiler
local ResolveTimer = ResolveTimer
local StopProfiler = StopProfiler
local SetHook = SetHook

local print = print
local table = table
local next = next
local pairs = pairs
local file = file
local string = string
local math = math
local tostring = tostring
local PrintTable = PrintTable
local type = type

module("profiler")

// lua_run require("profiler") profiler.Start()
// lua_run function a() for i=1,100000000 do end end a()
// lua_run profiler.Dump()

function Dump()
	StopProfiler()

	PrintTable(FuncData)

	local maxlen = 1
	local sorttable = {}
	for k,v in pairs(FuncData) do
		maxlen = math.max(maxlen, #k)
		table.insert(sorttable, {k, v.avg, v.max})
	end
	table.sort(sorttable, function(a, b) return a[3]>b[3] end)

	local buffer = {}
	local format = "%" .. tostring(maxlen) .. "s avg time: %.6f max time: %.6f"

	for k,v in pairs(sorttable) do
		table.insert(buffer, string.format(format, v[1], v[2], v[3]))
	end
	file.Write("profiler_functions_sorted_by_time.txt", table.concat(buffer, "\n"))
end

function Start()
	StartProfiler()
end

function Stop()
	StopProfiler()
end